function Wmn = SCoeff(mu_m,mu_c,k_m,k_c,D,m,n)




%% Solving the integral equation
nbPoints = D.nbPoints;


A11 = SingleL_Helm(k_c,D,D);
A12 = -SingleL_Helm(k_m,D,D);
A21 = (1/mu_c)*( (-1/2)*eye(nbPoints) + KDstar_Helm(k_c,D) );
A22 = (-1/mu_m)*( (+1/2)*eye(nbPoints) + KDstar_Helm(k_m,D) );
MatA = [A11, A12 ; A21, A22];

%%%%% The incident field is given by 
%%%%% J_n(k_m*|x|)*exp(i*n*theta) with n=3.

% evaluate J_n(k_m*|x|)*exp(i*n*theta) on the bdry of D
radial_part = besselj(n,k_m.*sqrt(D.points(1,:).^2 + D.points(2,:).^2) );
angular_part = exp(1i.*n.*angle(D.points(1,:) + 1i * D.points(2,:) ));
b1 = radial_part .* angular_part ;

% evaluate the normal derivative of J_n*exp(i*n*theta) on the bdry of D
ttt= 0.0001;
Dpoints_nbhd = D.points + ttt*D.normal;
radial_part_nbhd = besselj(n,k_m.*sqrt(Dpoints_nbhd(1,:).^2 + Dpoints_nbhd(2,:).^2) );
angular_part_nbhd = exp(1i.*n.*angle(Dpoints_nbhd(1,:) + 1i * Dpoints_nbhd(2,:) ));
b1_nbhd = radial_part_nbhd .* angular_part_nbhd ;
b2 = (b1_nbhd - b1)/ttt;

vecB = [b1.';1/mu_m*b2.'];


% get the density functions \psi
sol = MatA\vecB; 
psi = sol(nbPoints+1:2*nbPoints);



%% Compute the scattering coefficient

radial_part_m = besselj(m,k_m.*sqrt(D.points(1,:).^2 + D.points(2,:).^2) );
angular_part_m = exp(-1i.*m.*angle(D.points(1,:) + 1i * D.points(2,:) ));
JnExp = radial_part_m .* angular_part_m;

Wmn = (JnExp.*psi.')*D.sigma.';


